/*
 *	emu.c
 *
 *	ARCADIA/EMU
 *
 *	* Sun May 01 22:12:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

int
arcadia_init(const char* fname)
{
	FILE* fp;

	/* CNA܂B */
	memset(mem, 0, sizeof mem);

	/* ROMC[Wt@C[h܂B */
	fp = fopen(fname, "rb");
	if(!fp) {
		goto L_ERR;
	}
	fread(&mem[0x0000], 1, 0x1000, fp);	/* $0000-$0FFF: 擪 4KB      */
	fread(&mem[0x2000], 1, 0x6000, fp);	/* $2000-$7FFF: c24KB(max) */
	fclose(fp);

	/* UVIZbg܂B */
	uvi_reset(&mem[0x1800]);

	/* CPUZbg܂B */
	s2650_reset();

	return 0;
L_ERR:
	return -1;
}

/****************************************************************************
 *	
 ****************************************************************************/

/* %r10 s2650_read_io(%r12); */
/* void s2650_write_io(%r12, %r13); */
asm("
	.code
	.align	1
	.global	s2650_read_io
s2650_read_io:
	ret.d
	ld.w	%r10, 0			; *delay*
	.global	s2650_write_io
s2650_write_io:
	ret
");

int
arcadia_stream_callback(short* wbuff, int param)
{
	uvi_mix(wbuff);
	return 0;
}

void
input_update()
{
	int pad;
	int pot;
	int sw0;
	int sw1;
	int sw2;
	int sw3;

	pad = pcePadGetDirect();

	/* Y axis */
	if(pad & PAD_LF/*c:*/) {
		pot = 0x00;
	} else if(pad & PAD_RI/*c:*/) {
		pot = 0xf0;
	} else {
		pot = 0x70;
	}
	uvi_set_pot(0, pot);
	uvi_set_pot(1, pot);

	/* X axis */
	if(pad & PAD_DN/*c:*/) {
		pot = 0x00;
	} else if(pad & PAD_UP/*c:E*/) {
		pot = 0xf0;
	} else {
		pot = 0x70;
	}
	uvi_set_pot(2, pot);
	uvi_set_pot(3, pot);

	sw0 = 0; /* D3:0 = 1, 4, 7, Clear */
	sw1 = 0; /* D3:0 = 2(Action), 5, 8, 0 */
	sw2 = 0; /* D3:0 = 3, 6, 9, Enter */
	sw3 = 0; /* D2:0 = Option, Select, Start */
	if(pad & PAD_A) {
		sw1 |= (1<<3); /* 2(Action) */
	}
	if(pad & PAD_START) {
		sw3 |= (1<<0); /* Start */
	}
	if(pad & PAD_SELECT) {
		sw3 |= (1<<1); /* Select */
	}
	mem[0x1900] = mem[0x1904] = sw0;
	mem[0x1901] = mem[0x1905] = sw1;
	mem[0x1902] = mem[0x1906] = sw2;
	mem[0x1908]               = sw3;
}

/****************************************************************************
 *	
 ****************************************************************************/

int
arcadia_run(const char* fname, int sound_on)
{
	int cnt = 0;
	//
	unsigned char* draw;

	if(arcadia_init(fname) != 0) {
		return -1;
	}

	if(sound_on) {
		stream_play(TIABUFLEN, arcadia_stream_callback, 0, 0);
	}

	cnt = 0;
	for(;;) {
		/* ͍XVB */
		input_update();

		/* t[XLbvB */
		draw = NULL;
		if((cnt += FPS) >= 60) {
			cnt -= 60;
			draw = vbuff;
		}

		//-----------------------------------------------------------
		uvi_new_frame(draw);
		s2650_set_sense(0); /* Vblank=Off */
		do {
			s2650_run(ARCADIA_CLOCK/60/262);
		} while(!uvi_next_line());
		s2650_set_sense(1); /* Vblank=On */
		do {
			s2650_run(ARCADIA_CLOCK/60/262);
		} while(uvi_next_line());
		//-----------------------------------------------------------

		/* ʍXVB */
		if(draw) {
			uvi_reduce(draw, draw);
			schedule();
			/* START+SELECTŃQ[IB */
			if((joy & PAD_START) && (joy & PAD_SELECT)) {
				break;
			}
		}
	}

	if(sound_on) {
		stream_stop();
	}

	return 0;
}

/****************************************************************************
 *	
 ****************************************************************************/

